@echo off



::    ***************************************************************
::    ***************************************************************
::    *******                                                 *******
::    *******   IF YOU CAN SEE THIS SCRIPT IN YOUR BROWSER,   *******
::    *******                                                 *******
::    *******             PLEASE CLICK 'BACK' AND             *******
::    *******                                                 *******
::    *******        TRY DOWNLOADING THE .ZIP VERSION         *******
::    *******                                                 *******
::    ***************************************************************
::    ***************************************************************
































:: Original version by Luke
:: Extended to work on XP/Win7/Win8 and Office 2010/2013 by Bri

:: Fall through to profile directory if can't find Documents
:: Add DNS flush - Bri

:: Now with improved local time query (independent of date format)




set log=null

if exist "%userprofile%\My Documents" (
    set log=%userprofile%\My Documents\UCL-ISD-KMS-support.txt
)

if exist "%userprofile%\Documents" (
    set log=%userprofile%\Documents\UCL-ISD-KMS-support.txt
)

if "%log%" == "null" (
    set log=%userprofile%\UCL-ISD-KMS-support.txt
)


:: Always start a new file


echo UCL ISD Datacenter Service Team KMS Troubleshooting tool > "%log%"
echo ======================================================== >> "%log%"
echo. >> "%log%"

if not exist "%log%" (
    set log=%userprofile%\UCL-ISD-KMS-support.txt
)


echo %computername%, %date%, %time%
echo.
echo Running diagnostic tests, please wait...
echo ========================================
echo.

echo.>> "%log%"
echo ******************************************************************************* >> "%log%"
echo ============================== STARTING NEW TEST ============================== >> "%log%"
echo ******************************************************************************* >> "%log%"
echo.>> "%log%"
echo ============================== >> "%log%"
echo Hostname: %computername% >> "%log%"
echo.>> "%log%"
tzutil /g >> "%log%"
echo.>> "%log%"
echo.>> "%log%"
for /f %%# in ('wmic path win32_localtime get /format:value') do @for /f %%@ in ("%%#") do @set %%@
echo D: %day%    >> "%log%"
echo M: %month%  >> "%log%"
echo Y: %year%   >> "%log%"
echo.>> "%log%"
echo H: %hour%   >> "%log%"
echo M: %minute% >> "%log%"
echo S: %second% >> "%log%"
echo ============================== >> "%log%"
ver >> "%log%" 2>>&1
echo.>> "%log%"

echo .
echo.>> "%log%"
echo w32tm /stripchart >> "%log%"
echo ================= >> "%log%"
w32tm /stripchart /computer:ntp0.ucl.ac.uk /dataonly /samples:1 /packetinfo >> "%log%" 2>>&1

echo .
echo.>> "%log%"
echo ipconfig /flushdns >> "%log%"
echo ================== >> "%log%"
ipconfig /flushdns >> "%log%" 2>>&1

echo .
echo.>> "%log%"
echo ipconfig /all >> "%log%"
echo ============= >> "%log%"
ipconfig /all >> "%log%" 2>>&1

echo .
echo.>> "%log%"
echo nslookup -q=srv _vlmcs._tcp >> "%log%"
echo =========================== >> "%log%"
nslookup -q=srv _vlmcs._tcp >> "%log%" 2>>&1

echo .
echo.>> "%log%"
for /f "usebackq delims=: tokens=1,2" %%i in (`ipconfig /all`) do @if "%%i"=="        Primary Dns Suffix  . . . . . . . " set pridns=%%j
for /f "usebackq delims=: tokens=1,2" %%i in (`ipconfig /all`) do @if "%%i"=="   Primary Dns Suffix  . . . . . . . " set pridns=%%j

set pridns=%pridns:~1%
echo nslookup -q=srv _vlmcs._tcp.%pridns% >> "%log%"
echo =========================== >> "%log%"
nslookup -q=srv _vlmcs._tcp.%pridns% >> "%log%" 2>>&1

echo .
echo.>> "%log%"
echo slmgr.vbs /ato >> "%log%"
echo ============== >> "%log%"
(cscript "%SystemRoot%\System32\slmgr.vbs" /ato) >> "%log%" 2>>&1

echo .
echo.>> "%log%"
echo slmgr.vbs /dlv >> "%log%"
echo ============== >> "%log%"
(cscript "%SystemRoot%\System32\slmgr.vbs" /dlv) >> "%log%" 2>>&1
echo.>> "%log%"
echo.>> "%log%"

set ospp=null

if exist "%ProgramFiles(x86)%\Microsoft Office\Office14\ospp.vbs" set ospp=%ProgramFiles(x86)%\Microsoft Office\Office14\ospp.vbs
if exist "%ProgramW6432%\Microsoft Office\Office14\ospp.vbs" set ospp=%ProgramW6432%\Microsoft Office\Office14\ospp.vbs
if exist "%ProgramFiles%\Microsoft Office\Office14\ospp.vbs" set ospp=%ProgramFiles%\Microsoft Office\Office14\ospp.vbs

if exist "%ProgramFiles(x86)%\Microsoft Office\Office15\ospp.vbs" set ospp=%ProgramFiles(x86)%\Microsoft Office\Office15\ospp.vbs
if exist "%ProgramW6432%\Microsoft Office\Office15\ospp.vbs" set ospp=%ProgramW6432%\Microsoft Office\Office15\ospp.vbs
if exist "%ProgramFiles%\Microsoft Office\Office15\ospp.vbs" set ospp=%ProgramFiles%\Microsoft Office\Office15\ospp.vbs

if exist "%ProgramFiles(x86)%\Microsoft Office\Office16\ospp.vbs" set ospp=%ProgramFiles(x86)%\Microsoft Office\Office16\ospp.vbs
if exist "%ProgramW6432%\Microsoft Office\Office16\ospp.vbs" set ospp=%ProgramW6432%\Microsoft Office\Office16\ospp.vbs
if exist "%ProgramFiles%\Microsoft Office\Office16\ospp.vbs" set ospp=%ProgramFiles%\Microsoft Office\Office16\ospp.vbs


if "%ospp%" == "null" (
    echo.>> "%log%"
    echo Microsoft Office not found. >> "%log%"
    echo .
    echo.>> "%log%"
    goto nooffice
)


echo.>> "%log%"
echo Using "%ospp%" >> "%log%"

echo .
echo.>> "%log%"
echo ospp.vbs /act >> "%log%"
echo ============= >> "%log%"
(cscript "%ospp%" /act) >> "%log%" 2>>&1

echo .
echo.>> "%log%"
echo ospp.vbs /dstatusall >> "%log%"
echo ==================== >> "%log%"
(cscript "%ospp%" /dstatusall) >> "%log%" 2>>&1
echo.>> "%log%"
echo.>> "%log%"

:nooffice
echo .
echo Collecting product data - please wait a moment
echo .
echo.>> "%log%"
echo wmic product get name >> "%log%"
echo ===================== >> "%log%"
wmic /append:"%log%" product get name > nul:
echo.>> "%log%"
echo.>> "%log%"



echo .
echo.
echo Now please email the file:
echo.
echo "%log%"
echo.
echo to kms-support@ucl.ac.uk.

echo.
echo Press any key to open an Explorer window on this file . . .
pause >> nul:
explorer /select,"%log%"
